/*
 * tabmix.js
 *
 * code by Hemiola SUN
 * modified by Sunwan
 */
var gPrefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);

var nsIPrefServiceObj = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService);
var tmBranch = "extensions.tabmix.";
var tmPrefs = nsIPrefServiceObj.getBranch(tmBranch);

var __contentAreaClick = window.contentAreaClick;
var __BrowserOpenTab   = window.BrowserOpenTab;
var __BrowserLoadURL   = window.BrowserLoadURL;
var __whereToOpenLink  = window.whereToOpenLink;

function TM_init()
{
  window.contentAreaClick = TM_contentAreaClick;
  window.BrowserOpenTab   = TM_BrowserOpenTab;
  window.BrowserLoadURL   = TM_BrowserLoadURL;
  window.whereToOpenLink  = TM_whereToOpenLink;

  TM_prefImmigration();
  TM_Menu();
  gBrowser.onTabBarDblClick = TMonTabBarDblClick;

  gBrowser.mTabContainer.addEventListener("click", TM_checkClick, false);
  gBrowser.mTabContainer.addEventListener("select", gBrowser.tabcontainerSelect, false);
  gBrowser.mStrip.firstChild.nextSibling.addEventListener("popupshowing", TM_onTabbarContext, false);
  document.getElementById("contentAreaContextMenu").addEventListener("popupshowing", TM_checkContentMenu, false);

  tmlib.onUpdate();
  TM_checkToolsMenu();

  // override the duplicate tab function of All-in-One Gestures
  if (typeof aioDupTab == 'function') {
    aioDupTab = function() { gBrowser.duplicateTab(gBrowser.mCurrentTab); };
  }

  window.setTimeout( function () { tmlib.openToNextEnabled = true; }, 0 );
}

function TM_deinit ()
{
  window.contentAreaClick = __contentAreaClick;
  window.BrowserOpenTab   = __BrowserOpenTab;
  window.BrowserLoadURL   = __BrowserLoadURL;
  window.whereToOpenLink  = __whereToOpenLink;
}

// Create new items in the context menu of tab bar
//
var TM_newMenuItems = ["tm-duplicateTab","tm-separator","tm-closeAllTabs","tm-closeLeftTabs",
                    "tm-closeRightTabs","tm-undoCloseList"]; 
var TM_newMenuOrders = [ 1, 5, 6, 8, 9, 10];

function TM_prefImmigration () {
  try {
    gPref.setIntPref("browser.tabs.tabMaxWidth", tmPrefs.getIntPref("maxWidth")); // for Firefox 3.0
    tmPrefs.clearUserPref("maxWidth");
  }
  catch(e) {}
}

function TM_Menu () {
  for ( var i = 0; i < TM_newMenuItems.length; i++ ) {
    var newMenuItem = document.getElementById(TM_newMenuItems[i]);
    gBrowser.mStrip.firstChild.nextSibling.insertBefore( newMenuItem,
      gBrowser.mStrip.firstChild.nextSibling.childNodes[ TM_newMenuOrders[i] ] );
    newMenuItem.hidden = true;
  }
}

// check for tools menu items
//
function TM_checkToolsMenu () {
  var toolSR = document.getElementById("tm-toggleSR");
  toolSR.hidden = !tmPrefs.getBoolPref("toolsSR");
  toolSR.setAttribute("checked", gPrefs.getBoolPref("browser.sessionstore.resume_session_once") );
}

function TM_Startup()
{
  var TM_BrowserStartup = window.BrowserStartup;

  if (!gPrefService)
    gPrefService = Components.classes["@mozilla.org/preferences-service;1"]
                  .getService(Components.interfaces.nsIPrefBranch);

  var gB = document.getElementById("content");
  
  var aTab;
  for ( var i = 0; i < gB.mTabContainer.childNodes.length; i++ ) {
    aTab = gB.mTabContainer.childNodes[i];
    aTab.addEventListener("mousedown", TM_mousedownOnTab, true);
    aTab.addEventListener("click", TM_clickOnTab, true);
  }

  eval("gB.mTabProgressListener ="+gB.mTabProgressListener.toString().replace(
  'this.mTotalProgress = aMaxTotalProgress ?',
  'var mTabProgress = document.getAnonymousElementByAttribute(aTab, "class", "tab-text");'+
  'this.onStateChange(aWebProgress, aRequest);'+
  'if (aMaxTotalProgress < 1) return;'+
  'var percentage = parseInt((aCurTotalProgress * 100) / aMaxTotalProgress);'+
  'if (percentage > 0 && percentage < 100) mTabProgress.setAttribute("tab-progress", percentage);'+
  'this.mTotalProgress = aMaxTotalProgress ?'
  ).replace(
  'this.mTab.removeAttribute("busy");',
  'this.mTab.removeAttribute("busy");'+
  'if ( tmPrefs.getBoolPref("unreadTab") && this.mTab.hasAttribute("selected") && this.mTab.getAttribute("selected") == "false" ) this.mTab.removeAttribute("selected");'+
  'var mTabProgress = document.getAnonymousElementByAttribute(aTab, "class", "tab-text");'+
  'mTabProgress.setAttribute("tab-progress",0);'));

  TM_BrowserStartup();

  return;
}

// Function to catch changes to Tab Mix preferences and update existing windows and tabs
//
function TMprefObserver() {
  try {
    var pref = nsIPrefServiceObj.getBranch(null);
    this.pbi = pref.QueryInterface(Components.interfaces.nsIPrefBranchInternal);
    this.pbi.addObserver(tmBranch, this, true);
    this.pbi.addObserver("browser.tabs.", this, true);
  }
  catch(e) {
    alert("Tabx: prefs-Observer failed to attach: " + e + "\n");
  }
}

TMprefObserver.prototype = {
  // nsISupports interface implementation -- for weak-reference by pref-observer service
  QueryInterface: function(iid) {
    if (!iid.equals(Components.interfaces.nsISupports)
        && !iid.equals(Components.interfaces.nsISupportsWeakReference)
        && !iid.equals(Components.interfaces.nsIObserver)) {
      dump("Tab X pref-observer factory object: QI unknown interface: " + iid + "\n");
      throw Components.results.NS_ERROR_NO_INTERFACE;
    }
    return this;
  },

  // removes the observer-object from service -- called when the window is no longer open
  removeObserver: function() {
    this.pbi.removeObserver(tmBranch, this);
    this.pbi.removeObserver("browser.tabs.", this);
  },

  /* Observer-function */
  /* subject: [wrapped nsISupports :: nsIPrefBranch], nsIPrefBranchInternal
     topic: "changed"*/
  observe: function(subject, topic, prefName) {
    // if we don't have a valid window (closed)
    if ( !(typeof(document) == 'object' && document) ) {
      this.removeObserver(); // remove the observer..
      return;  // ..and don't continue
    }
    tmlib.onUpdate();
  }
}

// this handles special-case clicks
//
function TM_contentAreaClick(event, fieldNormalClicks)
{
  try {
    var targetPref = tmPrefs.getIntPref("target");
  }
  catch(e) {}
  // use the default if either of these are activated
  if ( targetPref == 1 )
    return __contentAreaClick(event, fieldNormalClicks);

  var target = event.target;
  var linkNode;

  if ( target instanceof HTMLButtonElement ||
       target instanceof HTMLInputElement ) {
    if ( typeof(SubmitToTab)!='undefined' && SubmitToTab.contentAreaClick(event) == false )
      return false;
  }
  if ( target instanceof HTMLAnchorElement ||
       target instanceof HTMLAreaElement ||
       target instanceof HTMLLinkElement ) {
    if (target.hasAttribute("href"))
      linkNode = target;
  }
  else {
    linkNode = event.originalTarget;
    while (linkNode && !(linkNode instanceof HTMLAnchorElement))
      linkNode = linkNode.parentNode;
    // <a> cannot be nested.  So if we find an anchor without an
    // href, there is no useful <a> around the target
    if (linkNode && !linkNode.hasAttribute("href"))
      linkNode = null;
    else if (linkNode && linkNode.hasAttribute("href"))
      target = linkNode;
  }

  if (!linkNode)
    return __contentAreaClick(event, fieldNormalClicks);
  var openT = linkNode.getAttribute("target");
  // If link has no target attribute, check if there is a <base> with a target attribute
  if (!openT) {
    var b = document.commandDispatcher.focusedWindow.document.getElementsByTagName("base");
    if (b.length > 0)
      openT = b[0].getAttribute("target");
  }

  if ( !event.shiftKey && !event.altKey && event.button != 2 &&
      linkNode.getAttribute("rel") != "sidebar" &&
      !(/^\s*javascript:/i.test(linkNode.href)) &&
      !(linkNode.href.indexOf("/#") > 0) &&
      !linkNode.hasAttribute("onclick") &&
      linkNode.href.indexOf("mailto:") != 0 &&
      (!openT || openT && openT != "_self" && openT != "_parent" &&
       openT != "_top" && openT != "_content" && openT != "_main" &&
       !TM_existsFrameName(document.commandDispatcher.focusedWindow.top.frames, openT)) ) {
    if ( targetPref == 0 )
      linkNode.setAttribute("target", "_blank");
    else if (openT)
      linkNode.setAttribute("target", "_top");
  }
  __contentAreaClick(event, fieldNormalClicks);

  return true;
}

/*
 * check a document's frame pool and determine if targetFrame is located inside of it
 *
 * PRECONDITION: containerFrame must be a valid reference to the current frame pool of the
 *  current document. targetFrame must be the frame that we are seeking.
 * POSTCONDITION: None.
 *
 */
function TM_existsFrameName(containerFrame, targetFrame) {
  for (var i = 0; i < containerFrame.length; ++i) {
    if (containerFrame[i].name == targetFrame)
      return true;
    if (containerFrame[i].frames.length)
      var return_var = TM_existsFrameName(containerFrame[i].frames,targetFrame);
  }

  if (return_var) return return_var;
  return false;
}

// load homepage in the new tab
function TM_BrowserOpenTab()
{
  try {
    var targetPref = tmPrefs.getBoolPref("loadHome");
  }
  catch(e) {}
  if ( targetPref == true) {
    var homePage = gHomeButton.getHomePage().split("|")[0];
    gBrowser.loadOneTab(homePage, null, null, null, false, false);
  }
  else {
    __BrowserOpenTab();
  }
  return;
}

function TM_BrowserLoadURL (aTriggeringEvent, aPostData)
{
  try {
    var targetPref = gPrefs.getBoolPref("browser.tabs.opentabfor.url");
  }
  catch(e) { }

  var url = gURLBar.value;

  if ( TM_IsBlankPage() )
    return loadURI(url, null, aPostData, true);
  if ( !targetPref )
    return __BrowserLoadURL(aTriggeringEvent, aPostData);

  if (aTriggeringEvent instanceof MouseEvent && aTriggeringEvent.button == 2)
    return true; // Do nothing for right clicks
  if ((gBrowser.localName == "tabbrowser" &&
      aTriggeringEvent && 'altKey' in aTriggeringEvent &&
      aTriggeringEvent.altKey) ||
      (aTriggeringEvent instanceof MouseEvent && aTriggeringEvent.button == 1)) {
    loadURI(url, null, aPostData, true /* allow third party fixup */);
  }
  else {
    handleURLBarRevert();
    (typeof focusElement == "function") ? focusElement(content) : content.focus();
    gBrowser.loadOneTab(url, null, null, aPostData, false,
                        true /* allow third party fixup */);
    aTriggeringEvent.preventDefault();
    aTriggeringEvent.stopPropagation();
  }

  (typeof focusElement == "function") ? focusElement(content) : content.focus();
  return true;
}