// code by Sunwan
var gPrefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);

function TM_whereToOpenLink (aEvent, ignoreButton, ignoreAlt) {
  var where, url;
  var targetPref = null;
  try {
    var prefBookmarks = gPrefs.getBoolPref("browser.tabs.opentabfor.bookmarks");
    var prefHistory = gPrefs.getBoolPref("browser.tabs.opentabfor.history");
    var prefSearch = gPrefs.getBoolPref("browser.search.openintab");
  }
  catch(e) {}

  if (aEvent == "bookmarks") {
    // for Firefox 2.* bookmarks onkeypress modify
    where = "current";
    targetPref = prefBookmarks;
  }
  else
    where = __whereToOpenLink(aEvent, ignoreButton, ignoreAlt);

  if ( !getTopWin() && where != "save" ) return "window";
  if ( where != "tab" && where != "current" ) return where;

  if (typeof aEvent == "object" && aEvent.currentTarget) {
    var id = aEvent.currentTarget.id || aEvent.currentTarget.getAttribute("anonid");
    try { url = aEvent.originalTarget.statusText; } catch(e) {}

    targetPref = prefBookmarks && ( id == "bookmarks-view" ||
      // Firefox 2
      id == "bookmarks-menu" || id == "bookmarks-ptf" || id == "bookmarks-tree" || id == "bookmarks-chevron" ||
      // Firefox 3
      id == "placesContext_openContainer:tabs" ||
      id == "bookmarksMenuPopup" || id == "bookmarksBarContent" || id == "placeContent" ) ||
      prefHistory && ( id == "historyTree" ||
      id == "go-menu" ||       // Firefox 2
      id == "history-menu") ||  // Firefox 3
      prefSearch && id == "search-go-button";
  }

  if (!url) {
    try {
      if (typeof PlacesController == "undefined") {
        // Firefox 2
        url = BookmarksUtils.getProperty( bookmarksView._selection.item[0].Value, gNC_NS + "URL",
                bookmarksView.db );
      }
      else {
        // Firefox 3
        url = aEvent.originalTarget.node.uri;
      }
    } catch(e) {}
  }

  if ( where == "tab" ) {
    if (targetPref && gPrefs.getBoolPref("extensions.tabmix.middlecurrent") || TM_IsBlankPage())
      where = "current";
  }
  else if ( where == "current" ) {
    if (targetPref && !TM_IsBlankPage() && !TM_IsBookmarklet(url) && !TM_LoadInSidebar(aEvent))
      where = "tab";
  }

  return where;
}

function TM_IsBlankPage() {
  var content = getTopWin().document.getElementById("content");
  return content && content.webNavigation.currentURI.spec == "about:blank" && 
          !content.mCurrentBrowser.webProgress.isLoadingDocument;
}

// Javascript bookmarklet
function TM_IsBookmarklet(url) {
  return /^javascript:\S+/i.test(url);
}

function TM_LoadInSidebar(event) {
  try {
    if (typeof PlacesController == "undefined") {
      // firefox 2
      if ("bookmarksView" in window) {
        var selection = bookmarksView._selection;
      }
      else {
        var aTarget = event.target;
        if (aTarget.getAttribute("class") == "openintabs-menuitem")
          aTarget = aTarget.parentNode.parentNode;
        if (!BookmarksMenu.isBTBookmark(aTarget.id))
          return false;
        var selection = BookmarksUtils.getSelectionFromResource(RDF.GetResource(aTarget.id));
      }
      var type = selection.type[0];
      if (type == "Bookmark" || type == "ImmutableBookmark") {
        var webPanel = BMDS.GetTarget(selection.item[0], RDF.GetResource(gNC_NS + "WebPanel"), true);
        if (webPanel) return true;
      }
    }
    else {
      // firefox 3
      var node = event.originalTarget.node || event.currentTarget.selectedNode;
      if (!node) return false;
      if ( PlacesUtils.nodeIsBookmark(node) &&
          PlacesUtils.annotations.itemHasAnnotation(node.itemId, LOAD_IN_SIDEBAR_ANNO) )
        return true;
    }
  } catch(e) {}
  return false;
}